#include <string>
#include <vector>
#include <iostream>
#include <fstream>

#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>

#define	DEST_IP		"127.0.0.1" //local host
#define	DEST_PORT	3131		//server port

#define STRING	std::string
#define CIN	std::cin
#define COUT	std::cout
#define ENDL	std::endl
#define VECTOR	std::vector<const char *>

std::ofstream logfile;
STRING procname;

//returnm -1 on error
int communicate(const VECTOR & to_send)
{
	logfile << "In communicate:" << ENDL;
	
	char msg[256];
	int sockfd;
	struct sockaddr_in dest_addr; // will hold the destination addr

	logfile << "Initializing socket" << ENDL;
	
	sockfd = socket(AF_INET, SOCK_STREAM, 0);

	if (sockfd == -1)
		return -1;

	dest_addr.sin_family = AF_INET; // host byte order
	dest_addr.sin_port = htons(DEST_PORT); // short, network byte order
	dest_addr.sin_addr.s_addr = inet_addr(DEST_IP);
	memset(&(dest_addr.sin_zero), '\0', 8); // zero the rest of the struct

	logfile << "Connecting to server" << ENDL;

	if (connect(sockfd, (struct sockaddr *)&dest_addr, sizeof(struct sockaddr)) == -1)
	{
		shutdown(sockfd, SHUT_RDWR);
		close(sockfd);
		return -1;
	}

	logfile << "Sending data" << ENDL << "{" << ENDL;

	int thesize = to_send.size();
	logfile << '\t' << "Number of elements: " << thesize << ENDL;
	send(sockfd, &thesize, sizeof(int), 0);
	
	for(int i = 0; i < to_send.size(); i++)
	{
		thesize = strlen(to_send[i]);
		logfile << '\t' << "Size of the elements: " << thesize << ENDL;
		send(sockfd, &thesize, sizeof(int), 0);
		logfile << '\t' << "Elements: " << to_send[i] << ENDL;
		send(sockfd, to_send[i], thesize, 0);
	}
	
	recv(sockfd, msg, 255, 0);
	COUT << msg << ENDL;
	logfile << msg << ENDL;

	shutdown(sockfd, SHUT_RDWR);
	close(sockfd);

	if(strncmp(msg, "Error:", 6) == 0)
		return -1;

	return 1;
}

int main()
{
	int args;
	char command[256];
	STRING allcommands[] = { "create", "access", "terminate"};
	char * argv[256];
	command[0] = 0;
	logfile.open("client.log");
	bool flag = false;
	bool grant = false;
	
	for(;;)
	{
		COUT << "/> ";
		CIN.getline( command, 255);
		
		while(command[0] == 0)
			CIN.getline( command, 255);
		
		args = 0;

		for( int ind = 0; command[ind] != 0;)
		{
			argv[args] = command + ind;			
				
			while( command[ind] != ' ' && command[ind] != 0)
				ind++;

			if( command[ind] != 0)
			{
				command[ind] = 0;
				ind++;
			}

			args++;	
			argv[args] = NULL;
		}
	
		if( argv[0] == NULL)
			continue;

		if( allcommands[0] == argv[0])
		{
			logfile << argv[0] << ENDL;
			
			if(!flag)
			{
				if( args == 3)
				{
					flag = true;
					procname = argv[1];
					VECTOR temp;
					temp.resize(3);
					temp[0] = argv[0];
					temp[1] = argv[1];
					temp[2] = argv[2];
logfile << "Process C: " << procname << ENDL;
					if(communicate(temp) == -1)
					{
						logfile << "Connection refused" << ENDL;
						COUT << "Cannot establish connection to server" << ENDL;
						break;
					}

					grant = true;
				}
				else
					COUT << "The create instruction gets 2 parameters !!" << ENDL;
			}
			else
				COUT << "You have used this instruction once" << ENDL;
		}
		else if( allcommands[1] == argv[0])
		{
			logfile << argv[0] << ENDL;
			
			if( args == 2)
			{
				if(grant)
				{
					VECTOR temp;
					temp.resize(3);
					temp[0] = argv[0];
					temp[1] = procname.c_str();
					temp[2] = argv[1];
logfile << "Process A: " << procname << ENDL;
					if(communicate(temp) == -1)
					{
						logfile << "Connection refused" << ENDL;
						COUT << "Cannot establish connection to server" << ENDL;
						break;
					}
				}
				else
					COUT << "You haven't register yet" << ENDL;
			}
			else
				COUT << "The access instruction gets 1 parameter !!" << ENDL;
		}
		else if( allcommands[2] == argv[0])
		{
			logfile << argv[0] << ENDL;

			if( args == 1)
			{
				if(grant)
				{
					VECTOR temp;
					temp.resize(2);
					temp[0] = argv[0];
					temp[1] = procname.c_str();

					if(communicate(temp) == -1)
					{
						logfile << "Connection refused" << ENDL;
						COUT << "Cannot establish connection to server" << ENDL;
					}
				}
				
				break;
			}
			else				
				COUT << "The terminate instruction gets 0 parameter !!" << ENDL;
		}
		else
		{
			COUT << "Unknown command !!" << ENDL;
			continue;
		}
	}

	logfile.close();
	return 0;
}


